from __future__ import annotations
# from ... import Http, File

from bagbag import * 

import typing 

# resp = Http.Get("https://nitter.kavin.rocks/search?f=tweets&q=psychologist+a+paradox+&since=&until=&near=")

# File("tweet.html").Write(resp.Content)

# data = File("tweet.html").Read()

# x = Tools.XPath(data)

# item = x.Find("/html/body/div/div/div[2]/div[1]")

class NitterTwitterUser():
    def __init__(self) -> None:
        self.ScreenName:str = None 

        self._favoriteCount:int = None 
        self._followersCount:int = None 
        self._statusesCount:int = None 
        self._friendsCount:int = None # 当前用户去follow别人的个数

        self._name:str = None 
        # self._id:int = None 
        self._location:str = None 
        self._registerTime:int = None 
        self._description:str = None 
        self._url:str = None
        # self._verified:bool = None 
        # self._listedCount:int = None 

        self.twitter:Nitter = None 
        self.infoHasBeenSet = False # 是否已经set过info
    
    def setInfoByHtml(self, html:str):
        # self.setInfoByHtmlByJson(html)
        # self.setInfoByHtmlByXPath(html)
        self.setInfoByHtmlByXPath1(html)

        self.infoHasBeenSet = True
    
    def setInfoByHtmlByJson(self, html:str):
        j = Json.Loads(html)

        # File("user.json").Write(Json.Dumps(j))

        for item in Json.ExtraValueByKey(j, 'div'):
            try:
                Lg.Trace([i['_attributes']['class'][0] for i in item])
                if "profile-bio" in [i['_attributes']['class'][0] for i in item]:
                    Lg.Trace(item)
                    break 
            except:
                pass 

    def setInfoByHtmlByXPath1(self, html:str):
        x = Tools.XPath(html)

        self._name:str = x.Find("//a[@class='profile-card-fullname']").Text()  
        # self._id:int = None 
        self._location:str = x.Find("//div[@class='profile-location']/span[2]").Text() if  x.Find("//div[@class='profile-location']/span[2]") else None
        self._registerTime:int = Time.Strptime(x.Find("//div[@class='profile-joindate']/span").Attribute("title"), "%I:%M %p - %d %b %Y")
        self._description:str = x.Find("//div[@class='profile-bio']").Text() if x.Find("//div[@class='profile-bio']") else None
        self._url:str = x.Find("//div[@class='profile-website']/span/a").Attribute("href") if x.Find("//div[@class='profile-website']/span/a") else None
        # self._verified:bool = None 
        # self._listedCount:int = None 

        self._favoriteCount = int(x.Find("//li[@class='likes']/span[2]").Text().replace(",", ""))
        self._followersCount = int(x.Find("//li[@class='followers']/span[2]").Text().replace(",", ""))
        self._friendsCount = int(x.Find("//li[@class='following']/span[2]").Text().replace(",", ""))
        self._statusesCount = int(x.Find("//li[@class='posts']/span[2]").Text().replace(",", ""))

        # Lg.Trace({
        #     "name": self._name,
        #     "location": self._location,
        #     "registerTime": self._registerTime,
        #     "description": self._description,
        #     "url": self._url,
        #     "favoriteCount": self._favoriteCount,
        #     "followersCount": self._followersCount,
        #     "friendsCount": self._friendsCount,
        #     "statusesCount": self._statusesCount,
        # })

    def setInfoByHtmlByXPath(self, html:str):
        x = Tools.XPath(html)
                
        tweetsCount = int(x.Find([
            "/html/body/div/div/div[2]/div[1]/div[2]/div[5]/ul/li[1]/span[2]",
            "/html/body/div/div/div[2]/div/div[2]/div[2]/ul/li[1]/span[2]",
        ]).Text().replace(",", ""))
        followingCount = int(x.Find([
            "/html/body/div/div/div[2]/div[1]/div[2]/div[5]/ul/li[2]/span[2]",
            "/html/body/div/div/div[2]/div/div[2]/div[2]/ul/li[2]/span[2]",
        ]).Text().replace(",", ""))
        followersCount = int(x.Find([
            "/html/body/div/div/div[2]/div[1]/div[2]/div[5]/ul/li[3]/span[2]",
            "/html/body/div/div/div[2]/div/div[2]/div[2]/ul/li[3]/span[2]",
        ]).Text().replace(",", ""))
        likesCount = int(x.Find([
            "/html/body/div/div/div[2]/div[1]/div[2]/div[5]/ul/li[4]/span[2]",
            "/html/body/div/div/div[2]/div/div[2]/div[2]/ul/li[4]/span[2]"
        ]).Text().replace(",", ""))

        self._favoriteCount = likesCount
        self._followersCount = followersCount
        self._friendsCount = followingCount
        self._statusesCount = tweetsCount

        # Lg.Trace({
        #     "tweetsCount": tweetsCount,
        #     "followingCount": followingCount,
        #     "followersCount": followersCount,
        #     "likesCount": likesCount,
        # })
    
    def setInfo(self):
        url = self.twitter.server + "/" + self.ScreenName
        
        html = self.twitter.getHTML(url)

        self.setInfoByHtml(html)
    
    @property
    def Name(self):
        if self._name == None and not self.infoHasBeenSet:
            self.setInfo()

        return self._name
    
    @property
    def Location(self):
        if self._location == None and not self.infoHasBeenSet:
            self.setInfo()

        return self._location
    
    @property
    def RegisterTime(self):
        if self._registerTime == None and not self.infoHasBeenSet:
            self.setInfo()

        return self._registerTime
    
    @property
    def Description(self):
        if self._description == None and not self.infoHasBeenSet:
            self.setInfo()

        return self._description
    
    @property
    def URL(self):
        if self._url == None and not self.infoHasBeenSet:
            self.setInfo()

        return self._url

    @property
    def FavoriteCount(self):
        if self._favoriteCount == None and not self.infoHasBeenSet:
            self.setInfo()
        
        return self._favoriteCount
    
    @property
    def FollowersCount(self):
        if self._followersCount == None and not self.infoHasBeenSet:
            self.setInfo()
        
        return self._followersCount
    
    @property
    def FriendsCount(self):
        if self._friendsCount == None and not self.infoHasBeenSet:
            self.setInfo()
        
        return self._friendsCount
    
    @property
    def StatusesCount(self):
        if self._statusesCount == None and not self.infoHasBeenSet:
            self.setInfo()
        
        return self._statusesCount
    
    def __repr__(self) -> str:
        return f"NitterTwitterUser(Name={self.Name} ScreenName={self.ScreenName} Location={self.Location} RegisterTime={self.RegisterTime} URL={self.URL} Description={self.Description} FollowersCount={self.FollowersCount} StatusesCount={self.StatusesCount} FavoriteCount={self.FavoriteCount})"

    def __str__(self) -> str:
        return self.__repr__()
    
    def getTimelineTweetsByHtmlByXPath(self, html:str) -> list[NitterTweet]:
        x = Tools.XPath(html)

        for idx in Range(1, 99):
            tlx = x.Find(f"//div[@class='timeline']/div[{idx}]")

            ipdb.set_trace()

            # weburl = 'https://twitter.com/' + x.Find(tlx + "/a").Attribute("href")
            # if x.Find(tlx + "/div/div[1]/div[1]").Attribute("class") in ["pinned", "retweet-header"]:
            #     continue 

            # 跳过转推
            if tlx.Find("//div[@class='retweet-header']") != None:
                continue 



            weburl = 'https://twitter.com/' + tlx.Find("//a[@class='tweet-link']").Attribute("href")




            

            Lg.Trace({
                "weburl": weburl
            })
            break 

        
    
    def getTimelineTweetsByHtml(self, html:str) -> list[NitterTweet]:
        return self.getTimelineTweetsByHtmlByXPath(html) 
    
    def Tweets(self) -> typing.Iterator[NitterTweet]:
        pass

class NitterTweet():
    def __init__(self) -> None:
        self.ID:int = None
        self.User:NitterTwitterUser = None 
        self.Time:int = None 
        self.Text:str = None 
        self.FavoriteCount:int = None 
        self.RetweetCount:int = None 
        self.CommentCount:int = None 
        self.WebURL:str = None 
        
        # self.in_reply_to_tweet_id:int = None
        # self.twitter:Nitter = None 

    def __repr__(self) -> str:
        return f"NitterTweet(ID={self.ID} Time={self.Time} Text={self.Text} User={self.User} FavoriteCount={self.FavoriteCount} RetweetCount={self.RetweetCount} CommentCount={self.CommentCount} WebURL={self.WebURL})"
    
    def __str__(self) -> str:
        return self.__repr__()

class Nitter():
    def __init__(self, server:str) -> None:
        self.server = server.rstrip("/") 

        if not self.server.startswith("http://") and not self.server.startswith("https://"):
            self.server = 'http://' + self.server

    def getSeachedTweet(self, html:str) -> list[NitterTweet]:
        # j = Json.Loads(html)

        # for item in j['html'][0]['body'][0]['div'][0]['div'][0]['div'][1]['div']:
        #     username = item['div'][0]['div'][0]['div'][0]['div'][0]['div'][0]['a'][0]["_value"]
        #     screenname = item['div'][0]['div'][0]['div'][0]['div'][0]['div'][0]['a'][1]["_value"]

        nts = []

        x = Tools.XPath(html)

        for idx in Range(1, 99):
            # /html/body/div/div/div[2]/div[1]
            # /html/body/div/div/div[2]/div[2]
            # /html/body/div/div/div[2]/div[1]/div/div[1]/div/div/div/a[1]
            basex = f"/html/body/div/div/div[2]/div[{idx}]"

            if x.Find(f"{basex}/div/div[1]/div/div/div/a[1]") == None:
                break 

            # Lg.Trace("/html/body/div/div/div[2]/div[1]/div/div[1]/div/div/div/a[1]")
            # Lg.Trace(f"{basex}/div/div[1]/div/div/div/a[1]")

            tid = x.Find(f"{basex}/a").Attribute("href").split("#")[0].split("/")[-1]

            username = x.Find(f"{basex}/div/div[1]/div/div/div/a[1]").Text()
            screenname = x.Find(f"{basex}/div/div[1]/div/div/div/a[2]").Text()[1:]

            text = ""
            section1 = x.Find(f"{basex}/div/div[2]")
            if section1.Attribute("class") == "replying-to":
                text = section1.Text().replace("Replying to", "RE") + " "
                textsidx = 3
            else:
                textsidx = 2

            text = text + x.Find(f"{basex}/div/div[{textsidx}]").Text()
            time = Time.Strptime(x.Find(f"{basex}/div/div[1]/div/div/span/a").Attribute("title"), "%b %d, %Y · %I:%M %p UTC")
            
            # /html/body/div/div/div[2]/div[5]/div/div[4]/span[1]
            # /html/body/div/div/div[2]/div[2]/div/div[4]
            comment = x.Find(f"{basex}/div/div[4]/span[1]").Text().strip()
            comment = int(comment) if String(comment).IsDigit() else 0

            retweet = x.Find(f"{basex}/div/div[4]/span[2]").Text().strip()
            retweet = int(retweet) if String(retweet).IsDigit() else 0

            quota = x.Find(f"{basex}/div/div[4]/span[3]").Text().strip()
            quota = int(quota) if String(quota).IsDigit() else 0

            like = x.Find(f"{basex}/div/div[4]/span[4]").Text().strip()
            like = int(like) if String(like).IsDigit() else 0

            ntu = NitterTwitterUser()
            ntu._name = username 
            ntu.ScreenName = screenname 
            ntu.twitter = self

            nt = NitterTweet()
            nt.CommentCount = comment
            nt.FavoriteCount = like
            nt.ID = tid 
            nt.RetweetCount = retweet
            nt.Text = text 
            nt.Time = time 
            nt.User = ntu 
            nt.WebURL = f"https://twitter.com/{nt.User.ScreenName}/status/{nt.ID}"

            nts.append(nt)

            # Lg.Trace({
            #     "tid": tid,
            #     "username": username,
            #     "screenname": screenname,
            #     "text": text,
            #     "time": time,
            #     "comment": comment, 
            #     "retweet": retweet,
            #     "quota": quota,
            #     "like": like
            # })

        return nts
    
    def getSeachedNextPageLink(self, html:str) -> str | None:
        url = String(html).RegexFind('<div class="show-more"><a href="(.+?)">Load more</a></div>')
        if len(url) == 0:
            return None   

        return self.server + "/search" + String(url[0][1]).HTMLDecode()

    def getHTML(self, url:str) -> str:
        resp = Http.Get(url)
        return resp.Content

    def Search(self, key:str) -> typing.Iterator[NitterTweet]:
        """
        注意: 不采集retweets.
        The function performs a search for tweets using a given key and returns an iterator of
        NitterTweet objects, excluding retweets.
        
        :param key: The `key` parameter is a string that represents the search query. It is used to
        search for tweets on Nitter (a decentralized and privacy-focused alternative to Twitter). The
        `key` is modified by appending the `-filter:retweets` operator to exclude retweets from the
        search results
        :type key: str
        """
        key += ' -filter:retweets'
        url = self.server + "/search?f=tweet&q=" + String(key).URLEncode()

        while True:
            html = self.getHTML(url)

            for t in self.getSeachedTweet(html):
                yield t 

            url = self.getSeachedNextPageLink(html)

            if url == None:
                break 
    
    def User(self, screenName:str) -> NitterTwitterUser:
        ntu = NitterTwitterUser()
        ntu.ScreenName = screenName
        ntu.twitter = self

        return ntu

if __name__ == "__main__":
    # ---- 调试 NitterTwitterUser - Timeline

    n = Nitter("nitter.kavin.rocks")

    ntu = n.User("blahlaja")
    html = File("user.html").Read()

    ntu.getTimelineTweetsByHtml(html)

    # ---- 联调 NitterTwitterUser, 从tweets里面 - info

    # 1

    # n = Nitter("nitter.kavin.rocks")
    # for t in n.Search("psychologist a paradox"):
    #     Lg.Trace(t)

    # Lg.Trace(t.User)

    # ---- 调试 NitterTwitterUser - info 

    # n = Nitter("nitter.kavin.rocks")

    # Lg.Trace(ntu)
    # ntu = n.User("blahlaja")
    # html = File("user.html").Read()

    # ntu = n.User("binsingha")
    # html = File("user.1.html").Read()

    # ntu.setInfoByHtml(html)

    # Lg.Trace(ntu)

    # ---- 调试 NitterTwitterUser - info

    # 活动频繁
    # html = Http.Get("https://nitter.kavin.rocks/blahlaja").Content
    # File("user.html").Write(html)

    # 没有推文
    # html = Http.Get("https://nitter.kavin.rocks/binsingha").Content
    # File("user.1.html").Write(html)

    # html = File("user.1.html").Read()

    # ntu = NitterTwitterUser()
    # ntu.setInfoByHtml(html)

    # ---- 联调 Nitter 

    # n = Nitter("nitter.kavin.rocks")

    # for t in n.Search("psychologist a paradox"):
    #     Lg.Trace(t)

    # ---- 调试 Nitter 
    
    # html = File("tweet.html").Read()

    # for i in n.parseTweetHtml(html):
    #     Lg.Trace(i)

    # html = Http.Get("https://nitter.kavin.rocks/search?f=tweets&q=psychologist+a+paradox+&cursor=1677510929099923455%26").Content

    # Lg.Trace(n.getNextPageLink(html))